# Source code for obspy.io.gse2.core

    # -*- coding: utf-8 -*-
    """
    GSE2/GSE1 bindings to ObsPy core module.
    """
    from __future__ import (absolute_import, division, print_function,
                            unicode_literals)
    from future.builtins import *  # NOQA

    import numpy as np

    from obspy import Stream, Trace
    from . import libgse1, libgse2

    def _is_gse2(filename):
        """
        Checks whether a file is GSE2 or not.

        :type filename: str
        :param filename: GSE2 file to be checked.
        :rtype: bool
        :return: ``True`` if a GSE2 file.
        """
        # Open file.
        try:
            with open(filename, 'rb') as f:
                libgse2.is_gse2(f)
        except Exception:
            return False
        return True

    def _read_gse2(filename, headonly=False, verify_chksum=True,
                   **kwargs):  # @UnusedVariable
        """
        Reads a GSE2 file and returns a Stream object.

        GSE2 files containing multiple WID2 entries/traces are supported.

        .. warning::
            This function should NOT be called directly, it registers via the
            ObsPy :func:`~obspy.core.stream.read` function, call this instead.

        :type filename: str
        :param filename: GSE2 file to be read.
        :type headonly: bool, optional
        :param headonly: If True read only head of GSE2 file.
        :type verify_chksum: bool, optional
        :param verify_chksum: If True verify Checksum and raise Exception if
            it is not correct.
        :rtype: :class:`~obspy.core.stream.Stream`
        :returns: Stream object containing header and data.

        .. rubric:: Example

        >>> from obspy import read
        >>> st = read("/path/to/loc_RJOB20050831023349.z")
        """
        traces = []
        with open(filename, 'rb') as f:
            # reading multiple gse2 parts
            while True:
                try:
                    if headonly:
                        header = libgse2.read_header(f)
                        traces.append(Trace(header=header))
                    else:
                        header, data = libgse2.read(f, verify_chksum=verify_chksum)
                        traces.append(Trace(header=header, data=data))
                except EOFError:
                    break
        return Stream(traces=traces)

    def _write_gse2(stream, filename, inplace=False, **kwargs):  # @UnusedVariable
        """
        Write GSE2 file from a Stream object.

        .. warning::
            This function should NOT be called directly, it registers via the
            the :meth:`~obspy.core.stream.Stream.write` method of an
            ObsPy :class:`~obspy.core.stream.Stream` object, call this instead.

        :type stream: :class:`~obspy.core.stream.Stream`
        :param stream: The ObsPy Stream object to write.
        :type filename: str
        :param filename: Name of file to write.
        :type inplace: bool, optional
        :param inplace: If True, do compression not on a copy of the data but
            on the data itself - note this will change the data values and make
            them therefore unusable!

        .. rubric:: Example

        >>> from obspy import read
        >>> st = read()
        >>> st.write('filename.gse', format='GSE2') #doctest: +SKIP
        """
        #
        # Translate the common (renamed) entries
        with open(filename, 'wb') as f:
            # write multiple gse2 parts
            for trace in stream:
                dt = np.dtype(np.int32)
                if trace.data.dtype.name == dt.name:
                    trace.data = np.ascontiguousarray(trace.data, dt)
                else:
                    msg = "GSE2 data must be of type %s, but are of type %s" % \
                        (dt.name, trace.data.dtype)
                    raise Exception(msg)
                libgse2.write(trace.stats, trace.data, f, inplace)

    def _is_gse1(filename):
        """
        Checks whether a file is GSE1 or not.

        :type filename: str
        :param filename: GSE1 file to be checked.
        :rtype: bool
        :return: ``True`` if a GSE1 file.
        """
        # Open file.
        with open(filename, 'rb') as f:
            try:
                data = f.readline()
            except Exception:
                return False
        if data.startswith(b'WID1') or data.startswith(b'XW01'):
            return True
        return False

    def _read_gse1(filename, headonly=False, verify_chksum=True,
                   **kwargs):  # @UnusedVariable
        """
        Reads a GSE1 file and returns a Stream object.

        GSE1 files containing multiple WID1 entries/traces are supported.

        .. warning::
            This function should NOT be called directly, it registers via the
            ObsPy :func:`~obspy.core.stream.read` function, call this instead.

        :type filename: str
        :param filename: GSE2 file to be read.
        :type headonly: bool, optional
        :param headonly: If True read only header of GSE1 file.
        :type verify_chksum: bool, optional
        :param verify_chksum: If True verify Checksum and raise Exception if
            it is not correct.
        :rtype: :class:`~obspy.core.stream.Stream`
        :returns: Stream object containing header and data.

        .. rubric:: Example

        >>> from obspy import read
        >>> st = read("/path/to/y2000.gse")
        """
        traces = []
        # read GSE1 file
        with open(filename, 'rb') as fh:
            while True:
                try:
                    if headonly:
                        header = libgse1.read_header(fh)
                        traces.append(Trace(header=header))
                    else:
                        header, data = \
                            libgse1.read(fh, verify_chksum=verify_chksum)
                        traces.append(Trace(header=header, data=data))
                except EOFError:
                    break
        return Stream(traces=traces)

### Thank you!

We would like to thank our contributors, whose efforts make this software what it is. These people have helped by writing code and documentation, and by testing. They have created and maintained this product, its associated libraries and applications, our build tools and our web sites.

#### Contributors

- Ackerley, Nick
- Allgeyer, Sebastien
- Ammon, Charles J.
- Antunes, Emanuel
- Arnarsson, Ólafur St.
- Bank, Markus
- Barsch, Robert
- Behr, Yannik
- Bernardi, Fabrizio
- Bernauer, Felix
- Bes de Berc, Maxime
- Beyreuther, Moritz
- Boltz, Shawn
- Bonaimé, Sébastien
- Carothers, Lloyd
- Chamberlain, Calum
- Chambers, Derrick
- Chen, Zhao
- Clark, Adam
- Danecek, Peter
- Egdorf, Sven
- Engels, Fabian
- Ermert, Laura
- Eulenfeld, Tom

- Fabbri, Tommaso
- Falco, Nicholas
- Fee, Jeremy
- Grellier, Clément
- Grunberg, Marc
- Hammer, Conny
- Heimann, Sebastian
- Heiniger, Lukas
- Hope, Gaute
- Igel, Heiner
- Inza, Adolfo
- Isken, Marius
- Ketchum, David
- Koymans, Mathijs
- Kremers, Simon
- Kress, Victor
- Krieger, Lars
- Krischer, Lion
- Kula, Damian
- Käufl, Paul
- Köhler, Andreas
- Lecocq, Thomas
- Leeman, John
- Legovini, Paride

- Lesage, Philippe
- Li, Yulin
- Lomax, Anthony
- Lopes, Rui L.
- MacCarthy, Jonathan
- Maggi, Alessia
- Martin, Henri
- Medlin, Andrew
- Megies, Tobias
- Meschede, Matthias
- Michelini, Alberto
- Miller, Nathaniel C.
- Morgenstern, Bernhard
- Nof, Ran Novitsky
- Panning, Mark P.
- Parker, Tom
- Pestourie, Romain
- Rapagnani, Giovanni
- Reyes, Celso
- Ringler, Adam
- Rothenhäusler, Nicolas
- Russo, Emiliano
- Sales de Andrade, Elliott

- Satriano, Claudio
- Saul, Joachim
- Scheingraber, Chris
- Schneider, Simon
- Sippl, Christian
- Snoke, Arthur
- Stange, Stefan
- Stähler, Simon C.
- Sullivan, Benjamin
- Tian, Dongdong
- Trabant, Chad
- Trani, Luca
- Uieda, Leonardo
- Walker, Andrew
- Walther, Marcus
- Wassermann, Joachim
- Williams, Mark C.
- Winkelman, Andrew
- Zaccarelli, Riccardo
- Zad, Seyed Kasra Hosseini
- Zhu, Lijun
- van Driel, Martin
- van Wijk, Kasper

#### Funds

ObsPy was partially funded by the

- German Science Foundation (DFG) via grant DFG IG 16/9-1
- German Ministry for Education and Research (BMBF), GEOTECHNOLOGIEN grant 03G0646H.
- NERA project (Network of European Research Infrastructures for Earthquake Risk Assessment and Mitigation) under the European Community's Seventh Framework Programme (FP7/2007-2013) grant agreement n° 262330
- Leibniz Institute for Applied Geophysics (LIAG)
- VERCE EU-FP7 project (no. 283543)